param VowelType = MascA | MascO | FemOE | FemE ; 
oper Suffix = (VowelType => Str) ;
     a4 = table { MascA => \m{"а"} ; MascO => "о" ; FemE => "э" ; FemOE => "ө" } ; 
     a3 = table { MascA => "а" ; MascO => "о" ; FemE | FemOE => "э" } ; 
     a2 = table { MascA | MascO => "а" ; FemE | FemOE => "э" } ; 
     i2 = table { MascA | MascO => "ы" ; FemE | FemOE => "ий" } ;     -- gen
     u2 = table { MascA | MascO => "у" ; FemE | FemOE => "ү" } ;      -- u/ue

    aa4 : Suffix = \\vt => a4!vt + a4!vt ;
    uu2 : Suffix = \\vt => u2!vt + u2!vt ;
    ai3 : Suffix = \\vt => a3!vt + "й" ;
    
  vowelType : Str -> VowelType = \stem -> case stem of { 
     _+("а"|"я"|"у")+?                             => MascA ;
     _+("ё"|"о")+?                                 => MascO ;
     _+"ө"+?                                       => FemOE ;
     _+("э"|"ү"|"е")+?                             => FemE ;
     _+?+("а"|"я"|"у")                             => MascA ;
     _+?+("ё"|"о")                                 => MascO ;
     _+?+"ө"                                       => FemOE ;
     _+?+("э"|"ү"|"е")                             => FemE ;
     (("а"|"я"|"у")+_)|(?+("а"|"я"|"у")+_)         => MascA ;
     (("ё"|"о")+_)|(?+("ё"|"о")+_)                 => MascO ;
     ("ө"+_)|(?+"ө"+_)                             => FemOE ;
     (("э"|"ү"|"е"|"и")+_)|(?+("э"|"ү"|"е"|"и")+_) => FemE ;
     _ => Predef.error (["vowelType does not apply to: "] ++ stem)
             } ; 
oper 
   Verb : Type = {s : VerbForm => Str ; vt : VowelType} ;

param VerbForm = 
     VInf
   | VFORM Voice Aspect VTense   -- Tense suffixes (TTS)
   | VIMP Directness Imperative  -- Person suffixes (PTS)
   | SVDS VoiceSub Subordination -- Subordinating (SVDS)
   | CVDS Anteriority   -- Coordinating suffixes (CVDS)
   | VPART Participle   -- indep.of Voice, Aspect (NDS)
   ; 
