concrete SplitSGer of SplitS = open NDeclGerNeu in {
  flags
    coding = utf8;
  param
    Tmp = Pres | Praet | Perf ;
    VForm = VFin Number Tmp  -- Pers=3 fix
          | VPart ;
    Aux = Sein | Haben ;
    Empty = Yes | No ;

  lincat 
    S =    { s : Tmp => Str } ;   
    NP =   { s : Case => {qnt,hd,rel : Str} ; 
             e : Empty ; -- Rel leer?
             n : Number ; g : Gender } ;
    N  =   { s : Number => Case => Str ; g : Gender } ;
    CN =   { s : Number => Case => Str ; 
             rel : Number => Str ; e : Empty ; g : Gender } ;
    V2 =   { s : VForm => {fin,inf:Str} ; c : Case } ;
    Qnt =  { s : Gender => Case => Str ; n : Number } ;  -- Gender bei Sg
    RelNP = { s : Gender => Number => Case => Str } ;
    RelS = { s : Gender => Number => Str } ;

    SPerf = { S : Str } ;

  lin
    He = UsePron he ;
    She = UsePron she ;
    They = UsePron they ;

    Game = mkN "Fußballspiel" "Fußballspiele" Neut sSg;

    UseN n = { s = n.s ; rel = \\n => "" ; e = Yes ; g = n.g } ;
    Like = (mkV "gefallen" "gefällt" "gefiel" "gefallen" Haben) ** { c = Dat }  ;
    See = (mkV "sehen" "sieht" "sah" "gesehen" Haben) ** { c = Acc } ;

    PredV2 subj v2 obj = 
       let num = subj.n ;
           pred : Tmp -> {fin,inf : Str} = \t -> (v2.s!(VFin num t)) ;
           c = v2.c ;
       in { s = table {t => (glue subj)!Nom ++ (pred t).fin
                                            ++ (glue obj)!c
                                            ++ (pred t).inf} 
       } ;
    PredV2ExtractRel subj v2 obj = 
       let num = subj.n ;
           pred : Tmp -> {fin,inf : Str} = \t -> (v2.s!(VFin num t)) ;
           c = v2.c ;
       in { s = table {t => (glue subj)!Nom 
                            ++ (pred t).fin
                            ++ (obj.s!c).qnt ++ (obj.s!c).hd 
                            ++ (pred t).inf
                            ++ (case obj.e of {Yes => "" ; 
                                               No => "," ++ (obj.s!c).rel ++ ","})}
       } ;
    PredV2TopicCN subj v2 obj = 
       let num = subj.n ;
           pred : Tmp -> {fin,inf : Str} = \t -> (v2.s!(VFin num t)) ;
           c = v2.c ;
       in { s = table{ t => (obj.s!c).hd 
                            ++ (case obj.e of { 
                                 No  => "," ++ (obj.s!c).rel ++ "," ;
                                 Yes => "" })
                            ++ (pred t).fin 
                            ++ (glue subj)!Nom 
                            ++ (obj.s!c).qnt
                            ++ (pred t).inf }
       } ;

    Few = { s = table{ g => table Case ["wenige" ; "weniger" ; 
                                        "wenigen" ; "wenige"] } ;
            n = Pl } ;

    QntCN q cn = { s = \\c => {qnt = q.s!cn.g!c ;
                               hd = cn.s!q.n!c ; 
                               rel = cn.rel!q.n } ;
                   e = cn.e ;
                   g = cn.g ; 
                   n = q.n } ;                      

    RelPron = let plTable : Case => Str = 
                  table Case ["die"; "derer"; "denen"; "die"] ;
              in
              { s = table{ Masc => table{ Sg => table Case ["der"; "dessen"; 
                                                            "dem"; "den"] ;
                                          Pl => plTable } ;
                           Fem  => table{ Sg => table Case ["die"; "derer"; 
                                                            "der"; "die"] ;
                                          Pl => plTable } ;
                           Neut => table{ Sg => table Case ["das"; "dessen"; 
                                                            "dem"; "das"] ;
                                          Pl => plTable }
                          }
              } ;
  
    RelCN cn rel = { s = cn.s ; 
                     rel = \\n => case cn.e of {Yes => "" ;
                                                No => cn.rel!n ++ "und"}
                                  ++ rel.s!cn.g!n ; 
                     e = No ;
                     g = cn.g } ;

    PredV2Rel rel v2 np = 
       let pred : Number -> Tmp -> Str = 
                    \n,t -> (v2.s!(VFin n t)).inf ++ (v2.s!(VFin n t)).fin ;
           c = v2.c ;
       in { s = \\g,n => table {t => rel.s!g!n!Nom 
                                     ++ (glue np)!c
                                     ++ (pred n t)} ! Pres
       } ;

    Perfekt s = { s = s.Perf } ;
               
  oper 
    Pron : Type = 
           { s : Case => Str ; 
             n : Number ; g : Gender } ;
    he:Pron = 
           { s = table Case ["er" ; "seiner" ; "ihm" ; "ihn"] ;
             n = Sg ; g = Masc } ;
    she:Pron =  
           { s = table Case ["sie" ; "ihrer" ; "ihr" ; "sie"] ;
             n = Sg ; g = Fem } ;
    they:Pron =  
           { s = table Case ["sie" ; "ihrer" ; "ihnen" ; "sie"] ;
             n = Pl ; g = Fem } ;
    UsePron : Pron -> NP = \p -> lin NP 
           { s = \\c => {qnt = [] ; rel = []; hd = p.s!c} ;
             e = Yes ;
             n = p.n ; g = p.g } ; 

    V : Type = { s : VForm => {fin,inf:Str} ; aux : Aux } ;
    mkV : (sehen,sieht,sah,gesehen : Str) -> Aux -> V = 
          \sehen,sieht,sah,gesehen,haben ->
           let aux : Number => Str = 
               case haben of { Haben => table{Sg => "hat" ; Pl => "haben"} ;
                               Sein  => table{Sg => "ist" ; Pl => "sind"} }
           in 
           { s = table{ VFin Sg Pres => {fin = sieht ; inf = ""} ;
                        VFin Sg Praet => {fin= sah ; inf = ""} ;
                        VFin num Perf => {fin = aux!num ; inf = gesehen} ;
                        VFin Pl Pres => {fin = sehen ; inf = ""} ;
                        VFin Pl Praet => {fin = sah+"en" ; inf = ""} ;
                        VPart => {fin = ""; inf = gesehen} } ;
             aux = haben } ;

    glue : NP -> Case => Str = 
          \np -> \\c => (np.s!c).qnt ++ (np.s!c).hd ++ 
                        (case np.e of {Yes => "" ; 
                                       No => "," ++ (np.s!c).rel ++ ","}) ;
    
} 
